﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Xml;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System.Threading;

namespace ConditionalFormatting
{
  public partial class Form1 : Form
  {
    public System.IO.MemoryStream stream, stream2;
    public System.Xml.XmlTextWriter xw2, xw;
    public XmlReader xr, xr2;
    public OleDbDataAdapter adapter;
    public DataSet dset;

    public Form1()
    {
      InitializeComponent();
      //this.gridGroupingControl1.Size = new System.Drawing.Size(650, 250);
      //OleDbConnection connection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\\..\\ACC.MDB");
      //adapter = new OleDbDataAdapter("SELECT * FROM Statistics", connection);
      //dset = new DataSet();
      //adapter.Fill(dset);
      //this.gridGroupingControl1.DataSource = dset.Tables[0];

      this.gridGroupingControl1.DataMember = "";
      this.gridGroupingControl1.DataSource = null;
      this.gridGroupingControl1.DataSource = this.dataSet191.WorkOrders;

      resetgrid(true);

      this.gridGroupingControl1.TableModel.EnableLegacyStyle = false;
      this.gridGroupingControl1.GridVisualStyles = GridVisualStyles.Office2010Blue;
      this.gridGroupingControl1.GridOfficeScrollBars = OfficeScrollBars.Metro;

      gridGroupingControl1.TableDescriptor.AllowEdit = false;
      gridGroupingControl1.TableDescriptor.AllowNew = false;
      gridGroupingControl1.TableDescriptor.AllowRemove = false;
      stream = new System.IO.MemoryStream();

      conditionalformatting();
    }
    public void conditionalformatting()
    {
      if (gridGroupingControl1.TableDescriptor.ConditionalFormats.Count == 0)
      {
        GridConditionalFormatDescriptor format = new GridConditionalFormatDescriptor("specialColor1");
        format.Expression = "[Pickup Status] like 'NR'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.LightGray;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor2");
        format.Expression = "[Pickup Status] like 'AP'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.LightGreen;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor3");
        format.Expression = "[Pickup Status] like 'ER'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.LightBlue;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor4");
        format.Expression = "[Pickup Status] like 'DC'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.MediumPurple;
        format.Appearance.AnyRecordFieldCell.TextColor = Color.White;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor5");
        format.Expression = "[Pickup Status] like 'WD'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.LightYellow;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor6");
        format.Expression = "[Pickup Status] like 'EF'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.Lavender;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor7");
        format.Expression = "[Pickup Status] like 'PF'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.Orange;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor8");
        format.Expression = "[Pickup Status] like 'IC'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.LightSalmon;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor9");
        format.Expression = "[Pickup Status] like 'CM'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.Gray;
        format.Appearance.AnyRecordFieldCell.TextColor = Color.White;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor10");
        format.Expression = "[Pickup Status] like 'PL'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.LightSkyBlue;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);

        format = new GridConditionalFormatDescriptor("specialColor11");
        format.Expression = "[Pickup Status] like 'OS'";
        format.Appearance.AnyRecordFieldCell.BackColor = Color.Salmon;
        gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format);
      }
    }
    private void button1_Click(object sender, EventArgs e)
    {
      //conditionalformatting();
      FileDialog dlg = new SaveFileDialog();
      dlg.AddExtension = true;
      dlg.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.*";
      if (dlg.ShowDialog() == DialogResult.OK)
      {
        xw = new XmlTextWriter(dlg.FileName, System.Text.Encoding.UTF8);
        xw.Formatting = System.Xml.Formatting.Indented;
        this.gridGroupingControl1.WriteXmlSchema(xw);
        xw.Close();
      }

    }

    private void button2_Click(object sender, EventArgs e)
    {
      FileDialog dlg = new OpenFileDialog();
      dlg.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.*";
      if (dlg.ShowDialog() == DialogResult.OK)
      {
        xr = new XmlTextReader(dlg.FileName);
        this.gridGroupingControl1.ApplyXmlSchema(xr);
        xr.Close();
      }

    }

    private void button3_Click(object sender, EventArgs e)
    {
      gridGroupingControl1.TableDescriptor.ConditionalFormats.Clear();

    }

    private void setgridstyle()
    {
      this.gridGroupingControl1.TableModel.EnableLegacyStyle = false;
      this.gridGroupingControl1.GridVisualStyles = GridVisualStyles.Office2010Blue;
      this.gridGroupingControl1.GridOfficeScrollBars = OfficeScrollBars.Metro;
    }

    public void noedit()
    {
      setgridstyle();
      
      gridGroupingControl1.TableDescriptor.AllowEdit = false;
      gridGroupingControl1.TableDescriptor.AllowNew = false;
      gridGroupingControl1.TableDescriptor.AllowRemove = false;

      conditionalformatting();
    }

    private void resetgrid(bool dogrp)
    {
      try
      {
        this.Cursor = Cursors.WaitCursor;

        System.Data.SqlClient.SqlDataAdapter dataAdapter = null;
        DataSet _dataSet = null;
        dataAdapter = new System.Data.SqlClient.SqlDataAdapter("select top 1 * from workorders", this.sqlConnection1);
        _dataSet = new DataSet();
        dataAdapter.Fill(_dataSet);

        this.gridGroupingControl1.CancelEdit();
        this.gridGroupingControl1.ResetTableDescriptor();

        this.gridGroupingControl1.Engine.DataMember = "";
        this.gridGroupingControl1.Engine.DataSource = null;
        this.gridGroupingControl1.Engine.DataSource = _dataSet.Tables[0];  // Workaround
        this.gridGroupingControl1.EndUpdate(false);

        this.gridGroupingControl1.TableModel.Selections.Clear();
        this.gridGroupingControl1.ResetTableDescriptor();
        this.gridGroupingControl1.DataMember = "";
        ((DataTable)this.gridGroupingControl1.DataSource).Clear();  
        this.gridGroupingControl1.DataSource = null;

        //adapter.Fill(dset);
        //this.gridGroupingControl1.DataSource = dset.Tables[0];

        this.gridGroupingControl1.DataSource = this.dataSet191.WorkOrders;
        this.gridGroupingControl1.CancelEdit();
        this.sqlDataAdapter1.Fill(this.dataSet191);

        if (dogrp)
          this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("W/O No");

        this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;
        this.gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.Any;
        noedit();
      }
      catch (Exception ex)
      {
        this.Cursor = Cursors.Arrow;
        MessageBox.Show("resetgrid: " + ex.ToString());
      }
      finally
      {
        this.Cursor = Cursors.Arrow;
      }

    }

    private void reloadgrid()
    {

      this.gridGroupingControl1.SuspendLayout();
      this.gridGroupingControl1.BeginUpdate();

      String pane = this.gridGroupingControl1.TableDescriptor.Name;
      System.IO.MemoryStream stream = new System.IO.MemoryStream();
      System.Xml.XmlTextWriter xw = new System.Xml.XmlTextWriter(stream, null);
      this.gridGroupingControl1.WriteXmlSchema(xw);
      stream.Position = 0;

      System.IO.MemoryStream stream2 = new System.IO.MemoryStream();
      System.Xml.XmlTextWriter xw2 = new System.Xml.XmlTextWriter(stream2, null);
      this.gridGroupingControl1.WriteXmlLookAndFeel(xw2);
      stream2.Position = 0;

      this.resetgrid(false);

      this.gridGroupingControl1.EndUpdate(true);
      this.gridGroupingControl1.ResumeLayout();

      Thread.Sleep(5000);

      Control.CheckForIllegalCrossThreadCalls = false;
      this.gridGroupingControl1.TableDescriptor.ConditionalFormats.Clear();
      noedit();

      System.Xml.XmlTextReader xr = new System.Xml.XmlTextReader(stream);
      System.Xml.XmlTextReader xr2 = new System.Xml.XmlTextReader(stream2);

      this.gridGroupingControl1.ApplyXmlSchema(xr);
      this.gridGroupingControl1.ApplyXmlLookAndFeel(xr2);

      this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;
      this.gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.Any;
      this.gridGroupingControl1.TableDescriptor.Name = pane;
      xw.Close();
      xr.Close();
      xw2.Close();
      xr2.Close();
      
      Control.CheckForIllegalCrossThreadCalls = true;

      //this.gridGroupingControl1.EndUpdate(true);
      //this.gridGroupingControl1.ResumeLayout();

      this.gridGroupingControl1.TableDescriptor.ConditionalFormats.Clear();
      noedit();
    }

    private void button4_Click(object sender, EventArgs e)
    {
      reloadgrid();

    }

    private void button5_Click(object sender, EventArgs e)
    {
      resetgrid(true);
    }
  }
}
